<template>
  <div>
    <div class="titulo">
      <div class="ruta">
        <v-breadcrumbs :items="breadcrumbs" :large="false">
          <template v-slot:divider>
            <v-icon>mdi-chevron-right</v-icon>
          </template>
        </v-breadcrumbs>
      </div>
      <strong>Atención de Hallazgos</strong>
    </div>
    <div class="contSecc">
      <busqueda-resumen 
        :idCeco = idCeco
        :idFase = idFase
        :idProyecto = idProyecto 
        />
      <div class="titSec ">Atención de hallazgo</div>
      <div class="gris">
        <div class="txtInfo">
          {{ detalleHallazgo.pregunta }}
        </div>
        <div class="contVisor">
          <div class="contenedor-visores">
            <visor-fotografia
              titulo="Evidencia actual"
              :dataLateral="dataLateral"
              :modoVista="modoVista"
              :detalleHallazgo="dataJson"
              ref="visor"
            ></visor-fotografia>
          </div>
        </div>
        <div class="btnCenter">
          <!-- <router-link to="/maquetado/hallazgos/busqueda-resultados"></router-link> -->
          <button class="btn btnB" @click="$router.go(-1)">Regresar</button>
          <button
            class="btn btnG"
            @click.stop="dialogRechazo = true"
            v-if="modoVista == 2 && perfilFranquicia" 
          >
            Rechazar
          </button>

          <!--v-if="modoVista != 3 " 
          @click.stop="dialogConfirmacion = true"-->
          <button
            class="btn"
            @click.stop="validaCampos()"
            v-if="getVisibility()"
          >
            <span v-if="!perfilFranquicia">Atender</span>
            <span v-if="perfilFranquicia">Autorizar</span>
          </button>
        </div>
      </div>
    </div>

    <!--Confirmación de cambios Hallazgos-->
    <v-dialog v-model="dialogConfirmacion" max-width="600">
      <v-card>
        <v-card-title class="headline"
          ><div class="titModal">Confirmación de cambios</div></v-card-title
        >
        <div class="contModal tCenter">
          <img src="@/assets/img/hallazgos/icoAlerta.svg" class="icoModal" />
          <div>¿Desea dar por entendido el hallazgo?</div>

          <div class="btnCenter">
            <button
              type="button"
              class="btn btnG"
              text
              @click="dialogConfirmacion = false"
            >
              No cancelar
            </button>
            <button
              type="button"
              class="btn"
              text
              @click="(dialogConfirmacion = false), atencionHallazgo(perfilFranquicia == true ? 3 : 2)"
            >
              Sí atender
            </button>
          </div>
        </div>
      </v-card>
    </v-dialog>

    <!--Cambios guardados con exito Hallazgos-->
    <v-dialog v-model="dialogGuardar" max-width="600">
      <v-card>
        <v-card-title class="headline"
          ><div class="titModal">Cambios guardados con éxito</div></v-card-title
        >
        <div class="contModal tCenter">
          <img src="@/assets/img/hallazgos/icoGuardar.svg" class="icoModal" />
          <div>
            Los cambios realizados <strong>se han guardado con éxito</strong>
          </div>

          <div class="btnCenter">
            <button
              type="button"
              class="btn btnG"
              text
              @click="(dialogGuardar = false), (dialogGuardarError = true)"
            >
              Cancelar
            </button>
            <button
              type="button"
              class="btn"
              text
              @click="(dialogGuardar = false), goToTablaHallazgos()"
            >
            <!--@click="(dialogGuardar = false), $router.go(-1)"-->
              Aceptar
            </button>
          </div>
        </div>
      </v-card>
    </v-dialog>

    <!--Error al guardar los cambios Hallazgos-->
    <v-dialog v-model="dialogGuardarError" max-width="600">
      <v-card class="errorM">
        <v-card-title class="headline">
          <div class="titModal titModaleError">
            Error al guardar los cambios
          </div>
        </v-card-title>
        <div class="contModal tCenter">
          <img
            src="@/assets/img/hallazgos/icoGuardarError.svg"
            class="icoModal"
          />
          <div>
            Ocurrió un error al guardar los cambios,
            <strong>por favor reintentalo</strong>
          </div>

          <div class="btnCenter">
            <button
              type="button"
              class="btn"
              text
              @click="(dialogGuardarError = false), atencionHallazgo(perfilFranquicia == true ? 3 : 2)"
            >
              Reintentar
            </button>
          </div>
        </div>
      </v-card>
    </v-dialog>

    <!--Motivo del rechazo Hallazgos-->
    <v-dialog v-model="dialogRechazo" max-width="600">
      <v-card>
        <v-card-title class="headline">
          <div class="titModal">Motivo del rechazo</div>
        </v-card-title>
        <div class="contModal tCenter">
          <img src="@/assets/img/hallazgos/icoAlerta.svg" class="icoModal" />
          <div>
            Para continuar, por favor indique el,
            <strong>motivo del rechazo</strong>
          </div>
          <br />
          <v-textarea solo v-model="motivoRechazo"></v-textarea>

          <div class="btnCenter" >
            <button
              type="button"
              class="btn btnG"
              text
              @click="dialogRechazo = false"
            >
              Cancelar
            </button>
            <button
              type="button"
              class="btn"
              text
              @click="(dialogRechazo = false), atencionHallazgo(0)"
            >
              Enviar
            </button>
          </div>
        </div>
      </v-card>
    </v-dialog>
  </div>
</template>

<script>
import BusquedaResumen from "@/views/secure/infraestructura/components/busqueda-resumen";
import VisorFotografia from "@/views/secure/infraestructura/components/visor-fotografia";
import store from "@/store";
import router from "@/router";
const axiosChecklist = store.state.axiosChecklist;
const serviceLocalStorage = store.state.serviceLocalStorage;
const serviceCommons = store.state.serviceCommons;
import axios from "axios";

export default {
  name: "Component-busquedaAtencion",
  components: {
    BusquedaResumen,
    VisorFotografia,
  },
  data () {
    return ({

    accionAtendido : false,

    cecoFaseProyecto: "",
    user : "",
    perfilFranquicia: false,
    modoVista: "",
    motivoRechazo: "",

    //data
    dataJson: null,
    detalleHallazgo: null,
    evidencias: null,
    idHallazgo: 0,
    idCeco: 0,
    idFase: 0,
    idProyecto: 0,
    hallazgos: null,

    //modal
    dialogConfirmacion: false,
    dialogGuardar: false,
    dialogGuardarError: false,
    dialogRechazo: false,

    //Slider
    imagenes: [
      { img: require("@/assets/img/hallazgos/tiendas/elektra1.jpg") },
      { img: require("@/assets/img/hallazgos/tiendas/elektra4.jpg") },
    ],
    model: 0,

    breadcrumbs: [
      
    ],

    dataLateral: null,
  })
  },
  created() {

    this.user = serviceLocalStorage.userToken();


    this.hallazgos = this.$route.params.hallazgos;
    this.idHallazgo = this.$route.params.idHallazgo;
    this.idCeco = this.$route.params.idCeco;
    this.idFase = this.$route.params.idFase;
    this.idProyecto = this.$route.params.idProyecto;
    this.nombreCeco = this.$route.params.nombreCecoParam;

    this.fase = this.$route.params.fase
    this.territorio = this.$route.params.territorio
    this.zona =this.$route.params.zona
    this.region =this.$route.params.region
    
  

    this.dataJson = this.$route.params.dataJson;

    const dataTransfer = {
        idProyecto: this.idProyecto,
        idFase: this.idFase,
        idCeco: this.idCeco,
        origenAtencion: false,
        fase: this.fase,
        territorio: this.territorio,
        zona: this.zona,
        region: this.region
    };

    this.cecoFaseProyecto = serviceCommons.objectToBase64(dataTransfer);
    
    this.initBreadcrumbs();
    this.initData(this.dataJson);
    this.isPerfilFranquicia();

    

    
   
  },
  methods: {
    initBreadcrumbs (){
      this.breadcrumbs = [
        {
          text: "Plataforma de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "home",
          },
        },
        {
          text: "Modelo de Entrega",
          disabled: false,
          exact: true,
          to: {
            name: "modelo_entrega"
          }
        },
        {
          text: "Busqueda Hallazgos",
          disabled: false,
          exact: true,
          to: {
            name: "modelo_franquicia_atencion_hallazgos"
            },
        },
        {
          text: "Listado hallazgos",
          disabled: false,
          exact: true,
          to: {
          name :"modelo_franquicia_lista_hallazgos",
          params: {
            cecoFaseProyecto: this.cecoFaseProyecto
            }
          }
        },
      {
        text: "Atención de Hallazgos",
        disabled: true,
      }
      ]

    },
    initData(data) {
      if (data != null) {
        var arrayImagenes = [];

        //Recorre Imagenes
        if (
          data.detalleEvidencias != null &&
          data.detalleEvidencias.length > 0
        ) {
          Object.keys(data.detalleEvidencias).forEach((key) => {
            var obj = data.detalleEvidencias[key];

            var imgSplit = obj.ruta.split(".");

            var imgProp = { nombreImg: imgSplit[0], formatoImg: imgSplit[1] };

            arrayImagenes.push(imgProp);
          });
        }

        if (data.detalleHallazgo.length > 0) {
          var imgSplit = "";
          var jsonImgAtencion = null;

          if (data.detalleHallazgo[0].ruta != null) {
            imgSplit = data.detalleHallazgo[0].ruta.split(".");
            jsonImgAtencion = {
              nombreImg: imgSplit[0],
              formatoImg: imgSplit[1],
            };
          }

          if (data.detalleHallazgo[0].status == 0) {
            this.modoVista = 1;
          } else if (data.detalleHallazgo[0].status == 1) {
            this.modoVista = 1;
          } else if (data.detalleHallazgo[0].status == 2) {
            this.modoVista = 2;
          } else if (data.detalleHallazgo[0].status == 3) {
            this.modoVista = 3;
          }
          this.detalleHallazgo = {
            obsAtencion: data.detalleHallazgo[0].obsAtencion,
            status: data.detalleHallazgo[0].status,
            pregunta: data.detalleHallazgo[0].preg,
            imagenes: arrayImagenes,
            //imagenes: [{nombreImg: "/franquicia/imagenes/2020/4985_20200629112135", formatoImg: "jpg"},{nombreImg: "/franquicia/imagenes/2020/4977_20200628104848", formatoImg: "jpg"},{nombreImg: "/franquicia/imagenes/2020/4985_20200629112135", formatoImg: "jpg"}],
            imagenes_atencion: jsonImgAtencion == null ? [] : [jsonImgAtencion],
            comentario: data.detalleHallazgo[0].obs,
            motivoRechazo: data.detalleHallazgo[0].motivrechazo,
            fechaHallazgo: data.detalleHallazgo[0].periodo,
          };
        }
        this.dataLateral = this.detalleHallazgo;
      }
    },
    atencionHallazgo(atencion) {
      var datosAtencion = null;
      var nombreArchivo1 = this.getToday().replace(" ","").replace(":","").replace(":","");

      datosAtencion = this.$refs.visor.validaDatos();

      var dataEnvio = {
        idUsuario: this.user.empleado,
        idHallazgo: this.idHallazgo,
        idFolio: this.dataJson.detalleHallazgo[0].idFolio,
        idResp: this.dataJson.detalleHallazgo[0].idResp,
        status: atencion,
        respuesta: atencion == 0 ? "NO" : "SI", //validar
        ruta: this.isCargaImagen(this.detalleHallazgo.status, atencion) ? 
          "/franquicia/imagenes/" +
          this.getAño() +
          "/" +
          this.idHallazgo +
          "_" +
          nombreArchivo1+
          ".jpg" : this.detalleHallazgo.imagenes_atencion[0].nombreImg + "." +this.detalleHallazgo.imagenes_atencion[0].formatoImg ,
        obs: this.dataJson.detalleHallazgo[0].obs,
        obsNueva:
          datosAtencion.observaciones != null
            ? datosAtencion.observaciones
            : "",
        fechaAut: this.getToday(),
        fechaFin: atencion == 3 ? this.getToday() : "",
        //usuModif: "WEB_HALAZGOS",
        usuModif:  this.user.empleado + " - " + this.user.nombre,
        motivoRechazo: this.motivoRechazo,
        tipoEvidencia: 21,
        idCeco: this.idCeco,
        idProyecto: this.idProyecto,
        idFase: this.idFase,
      };

      axiosChecklist
        .post("/expansionCoreServices/updateHallazgoExpansionDirecto.json", {
          hallazgos: [dataEnvio],
        })
        .then((response) => {
          if (response.status == 200) {
            if (response.data) {
              //ejecuta servicio para subir la foto
              if (
                this.dataJson.detalleHallazgo[0].status == 1 ||
                this.dataJson.detalleHallazgo[0].status == 0
              ) {
                this.cargaImagen(datosAtencion, atencion, nombreArchivo1);
              } else {
                this.dialogGuardar = true;
              }
            } else {
              this.dialogGuardarError = true;
            }
          }
        })
        .catch((error) => {
          this.dialogGuardarError = true;
        });
    },
    cargaImagen(datosAtencion, atencion,nombreArchivo) {
      var nombreArchivoParam =
        "" +
        this.idHallazgo +
        "_" +
        nombreArchivo+
        ".jpg";
      var archivoParam = datosAtencion.dataBase64.split(",")[1];

      //alert("El nombre del archivo es:"+nombreArchivoParam);

      if (
        atencion == 3 &&
        (datosAtencion.dataBase64 == null || datosAtencion.dataBase64 == "")
      ) {
        archivoParam;
      }

      var evidenciaAnterior = this.detalleHallazgo.imagenes_atencion[0];

      axiosChecklist
        .post("/expansionCoreServices/actualizaHallazgoImagenCore.json", {
          nomArchivo: nombreArchivoParam,
          archivo: archivoParam,
        })
        .then((response) => {
          if (response.status == 200) {
            if (response.data) {
              this.dialogGuardar = true;
            } else {
              this.dialogGuardarError = true;
            }
          }
        })
        .catch((error) => {
          console.log("Error en busqueda-atencion: " + error);
          this.dialogGuardarError = true;
        });
    },
    getAño() {
      return new Date().getFullYear();
    },
    getToday() {
      var hoy = new Date();

      const dia = hoy.getDate() < 10 ? "0" + hoy.getDate() : hoy.getDate();
      const mes =
        hoy.getMonth() + 1 < 10 ? "0" + (hoy.getMonth()+1) : (hoy.getMonth()+1);
      const anio = hoy.getFullYear();
      const hora = hoy.getHours() < 10 ? "0" + hoy.getHours() : hoy.getHours();
      const minutos =
        hoy.getMinutes() < 10 ? "0" + hoy.getMinutes() : hoy.getMinutes();
      const segundos =
        hoy.getSeconds() < 10 ? "0" + hoy.getSeconds() : hoy.getSeconds();

      return (
        anio + "" + mes + "" + dia + " " + hora + ":" + minutos + ":" + segundos
      );
    },
    getUser(){
      return localStorage.userToken();
    },
    isPerfilFranquicia(){
      var usuariosFranquicia = [ "200106","317298","96721","231334","972264","953954","189871","202622"];
      //var usuariosFranquicia = [ "189871","200106","317298","96721","231334","972264","953954"];

      usuariosFranquicia.forEach((currentValue, index, array)=>{
          if(this.user.empleado == usuariosFranquicia[index]){
            this.perfilFranquicia = true;
          }
      });
      
    },
    getVisibility(){

      var visible = false;

      if(this.detalleHallazgo.status == 2 && this.perfilFranquicia){
        visible =  true;
      }else if(this.detalleHallazgo.status == 2 && !this.perfilFranquicia){
        visible = false;
      }
      else if(this.modoVista != 3 ){
        visible = true;
      }else{
        visible =false;
      }

      return visible;

    },
    isCargaImagen(statusOrigen,  statusFinal){
        var cargaImagen = false;

        if (statusOrigen == 1 && statusFinal == 2 ){ // Por atender - Por autorizar
          cargaImagen = true;
        }else if(statusOrigen == 0 && statusFinal == 2){ //Rechazado por atender - Por autorizar
          cargaImagen = true;
        }else if(statusOrigen == 1 && statusFinal == 3){ // Por atender - Autorizado
          cargaImagen = true
        }else if(statusOrigen == 2 && statusFinal == 3){ // Por autorizar - Atendido
          cargaImagen ==  false;
        }else if(statusOrigen == 2 && statusFinal == 0){ // Por autorizar - Rechazar
          cargaImagen = false;
        }else if(statusOrigen == 0 && statusFinal == 3){ //Rechazado por atender - Autorizado
          cargaImagen = true;
        }

        return cargaImagen;


    },
    validaCampos(){

      //Se validaron los campos solo si el estatus del hallazgos esta en Rechazado por Atender o Por atender
      if(this.detalleHallazgo.status == 0 || this.detalleHallazgo.status == 1 ){
          if(this.$refs.visor.validaCampos()){
              this.dialogConfirmacion = true;
              this.accionAtendido = true

          }
      }else{
        this.accionAtendido = true
        this.dialogConfirmacion = true;
      }


    },
    goToTablaHallazgos(){
    
       var dataTransfer = {

        idProyecto: this.idProyecto,
        idFase: this.idFase,
        idCeco: this.idCeco,
        nombreCecoIni: this.nombreCeco,
        numCecoIni: this.idCeco,
        origenAtencion: true,
        fase: this.fase,
        territorio: this.territorio,
        zona: this.zona,
        region: this.region
        

      };


      router.push({
        name: "modelo_franquicia_lista_hallazgos",
        params: {
          cecoFaseProyecto: serviceCommons.objectToBase64(dataTransfer)
        }
      });

    }
  },
};
</script>

<style scoped>
.contEvidencia {
  width: 100%;
  border: 1px solid #ccc;
  background-color: #ffffff;
}
.medium {
  font-family: "AvenirNextLTPro-Medium";
  font-size: 15px;
  padding: 10px 0px;
}
.contenedor-visores {
  width: 98%;
  margin: 20px auto;
}
</style>
